Package io.vertx.rxjava3.ext.web.client

## Class CachingWebClient

- java.lang.Object
- - io.vertx.rxjava3.ext.web.client.CachingWebClient

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`

      public class CachingWebClient
      extends Object
      implements io.vertx.lang.rx.RxDelegate

  An asynchronous cache aware HTTP / HTTP/2 client called `CachingWebClient`.

  This client wraps a `WebClient` and makes it cache aware by adding features to it:

  - Cache-Control header parsing
  - Freshness checking

  The client honors the following cache headers:

  - Cache-Control with the following properties understood:
    - public
    - private
    - no-cache
    - no-store
    - max-age
    - s-maxage
    - stale-if-error
    - staile-while-revalidate
    - must-revalidate
  - Expires
  - ETag
  - Vary

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<CachingWebClient>` | `__TYPE_ARG` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `CachingWebClient​(CachingWebClient delegate)` |
    `CachingWebClient​(Object delegate)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static WebClient` | `create​(WebClient webClient)` | Create a cache aware web client using the provided `WebClient`.
    `static WebClient` | `create​(WebClient webClient, CachingWebClientOptions options)` | Create a cache aware web client using the provided `WebClient`.
    `static WebClient` | `create​(WebClient webClient, CacheStore cacheStore)` | Create a cache aware web client using the provided `WebClient`.
    `static WebClient` | `create​(WebClient webClient, CacheStore cacheStore, CachingWebClientOptions options)` | Create a cache aware web client using the provided `WebClient`.
    `boolean` | `equals​(Object o)` |
    `CachingWebClient` | `getDelegate()` |
    `int` | `hashCode()` |
    `static CachingWebClient` | `newInstance​(CachingWebClient arg)` |
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<CachingWebClient> __TYPE_ARG

  - ### Constructor Detail

    - #### CachingWebClient

          public CachingWebClient​(CachingWebClient delegate)

    - #### CachingWebClient

          public CachingWebClient​(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public CachingWebClient getDelegate()

      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`

    - #### create

          public static WebClient create​(WebClient webClient)

      Create a cache aware web client using the provided `WebClient`.
      Parameters:
        `webClient` - the web client instance
      Returns:
        the created web client

    - #### create

          public static WebClient create​(WebClient webClient,
                                         CacheStore cacheStore)

      Create a cache aware web client using the provided `WebClient`.
      Parameters:
        `webClient` - the web client instance
        `cacheStore` - the cache adapter
      Returns:
        the created web client

    - #### create

          public static WebClient create​(WebClient webClient,
                                         CachingWebClientOptions options)

      Create a cache aware web client using the provided `WebClient`.
      Parameters:
        `webClient` - the web client instance
        `options` - the caching web client options
      Returns:
        the created web client

    - #### create

          public static WebClient create​(WebClient webClient,
                                         CacheStore cacheStore,
                                         CachingWebClientOptions options)

      Create a cache aware web client using the provided `WebClient`.
      Parameters:
        `webClient` - the web client instance
        `cacheStore` - the cache adapter
        `options` - the caching web client options
      Returns:
        the created web client

    - #### newInstance

          public static CachingWebClient newInstance​(CachingWebClient arg)